<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Protocols  Reference</title>
    <link rel="stylesheet" type="text/css" href="css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="css/highlight.css" />
    <meta charset='utf-8'>
    <script src="js/jquery.min.js" defer></script>
    <script src="js/jazzy.js" defer></script>
    
    <script src="js/lunr.min.js" defer></script>
    <script src="js/typeahead.jquery.js" defer></script>
    <script src="js/jazzy.search.js" defer></script>
  </head>
  <body>
    <a name="//apple_ref/swift/Section/Protocols" class="dashAnchor"></a>
    <a title="Protocols  Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="index.html">madme_ios_sdk 6.2.1 Docs</a></p>
        <div class="header-right">
          <form role="search" action="search.json">
            <input type="text" placeholder="Search documentation" data-typeahead>
          </form>
        </div>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="index.html">madme_ios_sdk Reference</a>
        <img id="carat" src="img/carat.png" alt=""/>
        Protocols  Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="Classes.html">Classes</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Classes/AES.html">AES</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/AES/Error.html">– Error</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/AES/Variant.html">– Variant</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/AES/Encryptor.html">– Encryptor</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMAdPresentationError.html">MMAdPresentationError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMCampaign.html">MMCampaign</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMError.html">MMError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMGenericUserAccountStatusChangeContext.html">MMGenericUserAccountStatusChangeContext</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMHomeScreenOption.html">MMHomeScreenOption</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMNotificationProcessingError.html">MMNotificationProcessingError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMPrivateInitObject.html">MMPrivateInitObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMSdk.html">MMSdk</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMUrlProcessingError.html">MMUrlProcessingError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MMUrlSessionEventsProcessingError.html">MMUrlSessionEventsProcessingError</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes.html#/c:@M@madme_ios_sdk@objc(cs)MMViewedNoSurveyNoRatingCampaignContext">MMViewedNoSurveyNoRatingCampaignContext</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Enums.html">Enumerations</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Enums/BlockMode.html">BlockMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/CipherError.html">CipherError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMAdPresentationMode.html">MMAdPresentationMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMAdPresentationResultState.html">MMAdPresentationResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMAggregateQualifier.html">MMAggregateQualifier</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMHomeScreenOptionType.html">MMHomeScreenOptionType</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMNotificationProcessingResultState.html">MMNotificationProcessingResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMUrlProcessingResultState.html">MMUrlProcessingResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMUrlSessionEventsProcessingResultState.html">MMUrlSessionEventsProcessingResultState</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/MMUserAccountStatus.html">MMUserAccountStatus</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums.html#/PKCS7">PKCS7</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/Padding.html">Padding</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Extensions.html">Extensions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Extensions/Array.html">Array</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/MMCarouselCollectionViewController">MMCarouselCollectionViewController</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/MMGeoFencingCampaignDetailsViewController">MMGeoFencingCampaignDetailsViewController</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/MMPlist">MMPlist</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/NSNotification.html">NSNotification</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/Notification.html">Notification</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/Notification/Name.html">– Name</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/SecureBytes">SecureBytes</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions.html#/UIControl">UIControl</a>
              </li>
              <li class="nav-group-task">
                <a href="Extensions/UINavigationController.html">UINavigationController</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Protocols.html">Protocols</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Protocols/Cipher.html">Cipher</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/Cryptors.html">Cryptors</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMAdPresentationResultProtocol.html">MMAdPresentationResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols.html#/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProtocol">MMCampaignContextProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols.html#/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProviderProtocol">MMCampaignContextProviderProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMClientIdentityProviderProtocol.html">MMClientIdentityProviderProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMNotificationProcessingResultProtocol.html">MMNotificationProcessingResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols.html#/c:@M@madme_ios_sdk@objc(pl)MMSdkDelegateProtocol">MMSdkDelegateProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUrlProcessingResultProtocol.html">MMUrlProcessingResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUrlSessionEventsProcessingResultProtocol.html">MMUrlSessionEventsProcessingResultProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUserAccountStatusChangeContextProtocol.html">MMUserAccountStatusChangeContextProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/MMUserAccountStatusDelegateProtocol.html">MMUserAccountStatusDelegateProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/PaddingProtocol.html">PaddingProtocol</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/Updatable.html">Updatable</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Structs.html">Structures</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Structs/Digest.html">Digest</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Typealiases.html">Type Aliases</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:13madme_ios_sdk12MMIdentifiera">MMIdentifier</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            <h1>Protocols</h1>
            <p>The following protocols are available globally.</p>

          </section>
          <section class="section task-group-section">
            <div class="task-group">
              <div class="task-name-container">
                <a name="/MMNotificationListCampaignDetailsViewController"></a>
                <a name="//apple_ref/swift/Section/MMNotificationListCampaignDetailsViewController" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/MMNotificationListCampaignDetailsViewController"></a>
                  <h3 class="section-name"><span>MMNotificationListCampaignDetailsViewController</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMUserAccountStatusChangeContextProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMUserAccountStatusChangeContextProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMUserAccountStatusChangeContextProtocol">MMUserAccountStatusChangeContextProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Protocol that defines the context of a user account status change.</p>

                        <a href="Protocols/MMUserAccountStatusChangeContextProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMUserAccountStatusChangeContextProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMUserAccountStatusDelegateProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMUserAccountStatusDelegateProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMUserAccountStatusDelegateProtocol">MMUserAccountStatusDelegateProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Client applications that require custom opt-in/opt-out behavior must adopt this or an inheriting protocol.</p>

                        <a href="Protocols/MMUserAccountStatusDelegateProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMUserAccountStatusDelegateProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/MMAggregateQualifier"></a>
                <a name="//apple_ref/swift/Section/MMAggregateQualifier" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/MMAggregateQualifier"></a>
                  <h3 class="section-name"><span>MMAggregateQualifier</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMClientIdentityProviderProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMClientIdentityProviderProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMClientIdentityProviderProtocol">MMClientIdentityProviderProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Client applications that provide client-specific identifiers must adopt this or an inheriting protocol.</p>

                        <a href="Protocols/MMClientIdentityProviderProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMClientIdentityProviderProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMSdkDelegateProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMSdkDelegateProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMSdkDelegateProtocol">MMSdkDelegateProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>mAdme SDK umbrella protocol. Client applications should adopt this protocol instead of the inherited protocols.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMSdkDelegateProtocol</span><span class="p">:</span> <span class="kt"><a href="Protocols/MMClientIdentityProviderProtocol.html">MMClientIdentityProviderProtocol</a></span><span class="p">,</span>
    <span class="kt"><a href="Protocols/MMUserAccountStatusDelegateProtocol.html">MMUserAccountStatusDelegateProtocol</a></span><span class="p">,</span> <span class="kt"><a href="Protocols.html#/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProviderProtocol">MMCampaignContextProviderProtocol</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProviderProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMCampaignContextProviderProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProviderProtocol">MMCampaignContextProviderProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Client applications may adopt this or an inheriting protocol to provide the context of the cached campaign updates. See also MMCampaignContextProtocol.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMCampaignContextProviderProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMCampaignContextProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMCampaignContextProtocol">MMCampaignContextProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Client applications may adopt this or an inheriting protocol to implement a context for the cached campaign updates. E.g., see also MMViewedNoSurveyNoRatingCampaignContext for a default implementation.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMCampaignContextProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/Reading%20XML%2FJSON%20files"></a>
                <a name="//apple_ref/swift/Section/Reading XML/JSON files" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/Reading%20XML%2FJSON%20files"></a>
                  <h3 class="section-name"><span>Reading XML/JSON files</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:13madme_ios_sdk9UpdatableP"></a>
                    <a name="//apple_ref/swift/Protocol/Updatable" class="dashAnchor"></a>
                    <a class="token" href="#/s:13madme_ios_sdk9UpdatableP">Updatable</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>A type that supports incremental updates. For example Digest or Cipher may be updatable
and calculate result incerementally.</p>

                        <a href="Protocols/Updatable.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">Updatable</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/Cipher"></a>
                <a name="//apple_ref/swift/Section/Cipher" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/Cipher"></a>
                  <h3 class="section-name"><span>Cipher</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/"></a>
                    <a name="//apple_ref/swift/Protocol/Cryptors" class="dashAnchor"></a>
                    <a class="token" href="#/">Cryptors</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Worker cryptor/decryptor of <code><a href="Protocols/Updatable.html">Updatable</a></code> types</p>

                        <a href="Protocols/Cryptors.html" class="slightly-smaller">See more</a>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/"></a>
                    <a name="//apple_ref/swift/Protocol/Cipher" class="dashAnchor"></a>
                    <a class="token" href="#/">Cipher</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        
                        <a href="Protocols/Cipher.html" class="slightly-smaller">See more</a>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/Encryptor"></a>
                <a name="//apple_ref/swift/Section/Encryptor" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/Encryptor"></a>
                  <h3 class="section-name"><span>Encryptor</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/"></a>
                    <a name="//apple_ref/swift/Protocol/PaddingProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/">PaddingProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        
                        <a href="Protocols/PaddingProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/MMAdPresentationResultProtocol"></a>
                <a name="//apple_ref/swift/Section/MMAdPresentationResultProtocol" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/MMAdPresentationResultProtocol"></a>
                  <h3 class="section-name"><span>MMAdPresentationResultProtocol</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMAdPresentationResultProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMAdPresentationResultProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMAdPresentationResultProtocol">MMAdPresentationResultProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Protocol that all mAdme ad-presentation results must conform to. Not meant to be adopted by applications.</p>

                        <a href="Protocols/MMAdPresentationResultProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMAdPresentationResultProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/MMUrlSessionEventsProcessingResultProtocol"></a>
                <a name="//apple_ref/swift/Section/MMUrlSessionEventsProcessingResultProtocol" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/MMUrlSessionEventsProcessingResultProtocol"></a>
                  <h3 class="section-name"><span>MMUrlSessionEventsProcessingResultProtocol</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMUrlSessionEventsProcessingResultProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMUrlSessionEventsProcessingResultProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMUrlSessionEventsProcessingResultProtocol">MMUrlSessionEventsProcessingResultProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Protocol that all mAdme url-session events processing results must conform to. Not meant to be adopted by applications.</p>

                        <a href="Protocols/MMUrlSessionEventsProcessingResultProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMUrlSessionEventsProcessingResultProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/MMUrlProcessingResultProtocol"></a>
                <a name="//apple_ref/swift/Section/MMUrlProcessingResultProtocol" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/MMUrlProcessingResultProtocol"></a>
                  <h3 class="section-name"><span>MMUrlProcessingResultProtocol</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMUrlProcessingResultProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMUrlProcessingResultProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMUrlProcessingResultProtocol">MMUrlProcessingResultProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Protocol that all mAdme url processing results must conform to. Not meant to be adopted by applications.</p>

                        <a href="Protocols/MMUrlProcessingResultProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMUrlProcessingResultProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <div class="task-name-container">
                <a name="/MMNotificationProcessingResultProtocol"></a>
                <a name="//apple_ref/swift/Section/MMNotificationProcessingResultProtocol" class="dashAnchor"></a>
                <div class="section-name-container">
                  <a class="section-name-link" href="#/MMNotificationProcessingResultProtocol"></a>
                  <h3 class="section-name"><span>MMNotificationProcessingResultProtocol</span>
</h3>
                </div>
              </div>
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@madme_ios_sdk@objc(pl)MMNotificationProcessingResultProtocol"></a>
                    <a name="//apple_ref/swift/Protocol/MMNotificationProcessingResultProtocol" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@madme_ios_sdk@objc(pl)MMNotificationProcessingResultProtocol">MMNotificationProcessingResultProtocol</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Protocol that all mAdme notification processing results must conform to. Not meant to be adopted by applications.</p>

                        <a href="Protocols/MMNotificationProcessingResultProtocol.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@objc</span>
<span class="kd">public</span> <span class="kd">protocol</span> <span class="kt">MMNotificationProcessingResultProtocol</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
          </section>
        </section>
        <section id="footer">
          <p>&copy; 2022 <a class="link" href="http://www.mad-me.com" target="_blank" rel="external noopener">mAdme</a>. All rights reserved. (Last updated: 2022-07-05)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external noopener">jazzy ♪♫ v0.14.2</a>, a <a class="link" href="https://realm.io" target="_blank" rel="external noopener">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</html>
